#include <bits/stdc++.h>
#define ll long long
#define ff first
#define pb push_back
#define ss second
#define endl '\n'
#define y1 y6
#define j1 j6
#define rr return 0;
using namespace std;
ll n,i,o,d,m,j,x,y;
const ll INF=1e9;
vector < ll > v[100007];
set < ll > st;
ll B[100007];
void rec (ll n)
{

}
int main()
{
//    freopen("loganqueries.in","r",stdin);
//    freopen("loganqueries.out","w",stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m;
    for(i=0;i<m;i++)
    {
        cin>>x>>y;
        x--; y--;
        v[x].pb(y);
    }
    cout<<"NO";
    return 0;
    rec(n);
    return 0;
}
